unit PermanentModuleUnit;

interface

uses
    SysUtils,
    Classes,
    SxPmtDataModule,
    SxProvider,
    SxIconList,
    Menus,
    SxPopupMenu, SxCustShlObj, SxPropertySheetExt, SxNamespacePropSheet;

type
  TPermanentModule = class(TSxPermanentModule)
    GrainPropertySheet: TSxNamespacePropertySheet;
    ByHandProvider: TSxByHandProvider;
    procedure ByHandProviderPopulate(Sender: TSxByHandProvider;
      DataGrain: TSxByHandDataGrain; GrainList: TList);
    procedure ByHandProviderGetGrainFilename(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; var FileName: WideString);
    procedure ByHandProviderPrepareGrainApperance(
      Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
      var IconParams: TSxPrepareIconParams);
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TPermanentModule.ByHandProviderPopulate(
  Sender: TSxByHandProvider; DataGrain: TSxByHandDataGrain;
  GrainList: TList);
var
  TempFolder:String;
  SearchRec:TSearchRec;
  TempGrain:TSxCustomDataGrain;
begin
  if DataGrain.IsRoot then
     TempFolder:='C:\'
  else
  begin
    DataGrain.Data.Seek(0,0);
    TempFolder:=DataGrain.GrainID;
  end;
  if FindFirst(IncludeTrailingBackSlash(TempFolder)+'*',faAnyFile,SearchRec)=0 then
  try
    repeat
      if (SearchRec.Name='.') or (SearchRec.Name='..') then
         Continue;
      if (SearchRec.Attr and faDirectory)<>faDirectory then
         Continue;
      TempGrain:=Sender.CreateGrainInstance;
      TempGrain.Name:=SearchRec.Name;
      TempGrain.GrainType:=gtFolder;
      // Actually this property can be used to store the unique grain identifier
      tempGrain.GrainID:=IncludeTrailingBackslash(TempFolder)+SearchRec.Name;
      GrainList.Add(TempGrain);
    until FindNext(SearchRec)<>0;
  finally
    SysUtils.FindClose(SearchRec);
  end;

  if FindFirst(IncludeTrailingBackSlash(TempFolder)+'*',faAnyFile,SearchRec)=0 then
  try
    repeat
      if (SearchRec.Name='.') or (SearchRec.Name='..') then
         Continue;
      if (SearchRec.Attr and faDirectory)=faDirectory then
         Continue;
      TempGrain:=Sender.CreateGrainInstance;
      TempGrain.Name:=SearchRec.Name;
      TempGrain.GrainType:=gtItem;
      // Actually this property can be used to store the unique grain identifier
      tempGrain.GrainID:=IncludeTrailingBackslash(TempFolder)+SearchRec.Name;
      GrainList.Add(TempGrain);
    until FindNext(SearchRec)<>0;
  finally
    SysUtils.FindClose(SearchRec);
  end;
end;

procedure TPermanentModule.ByHandProviderGetGrainFilename(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  var FileName: WideString);
begin
  if DataGrain.GrainType = gtFolder then
     FileName:=''
  else
  begin
    DataGrain.Data.Seek(0,0);
    FileName:=DataGrain.GrainID;
  end;
end;

procedure TPermanentModule.ByHandProviderPrepareGrainApperance(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  var IconParams: TSxPrepareIconParams);
begin
  IconParams.UseSystemIcon:=True;
end;

initialization
  RegisterPermanentModuleClass(TPermanentModule);
end.









 
 

